# compiler.py
#
import sys
typeInt = type(5)

def getExpr(tokens) :
    code1,rest = getTerm(tokens)
    if code1 == None : return None, rest
    byteCode = code1
    while True :
        oper,rest = getOper(rest, ["+","-"])
        if not oper : return byteCode,rest   # good return
        code2,rest = getTerm(rest)
        if code2 == None : fatal("getExpr","no following unit")
        byteCode += code2 + (oper,)

def getTerm(tokens) :
    code1,rest = getUnit(tokens)
    if code1 == None : return None, rest
    byteCode = code1
    while True :
        oper,rest = getOper(rest, ["*","/"])
        if not oper : return byteCode, rest   # good return
        code2,rest = getUnit(rest)
        if code2 == None : fatal("getTerm","no following unit")
        byteCode += code2 + (oper,)

def getUnit(tokens) :
    if not tokens : return (None, [])
    tok,rest = tokens[0], tokens[1:]
    if type(tok) == typeInt : return (tok,), rest
    elif tok == '-' :
        unit,rest = getUnit(rest)
        if unit == None : fatal("getUnit","Invalid expr")
        else : return (unit)+("~",),rest
    elif tok == "(" :
        byteCode,rest = getExpr(rest)
        if byteCode == None : fatal("getUnit","Invalid sub-byteCode")
        tok,rest = getOper(rest,[')'])
        if tok : return (byteCode, rest)
        else   : fatal("getUnit","no closing paran")

def getOper(tokens, valid) :
    if tokens and tokens[0] in valid :
        return tokens[0], tokens[1:]
    else : return None, tokens

def fatal(who, mesg) :
    print("fatal -- %s %s" % (who,mesg))
    sys.exit()

def main() :
    import lexer
    code   = sys.argv[1]
    tokens = lexer.lexScan(code)
    print("Lexer gives %s" % tokens)
    value,rest = getExpr(tokens)
    print("%s %s" % (value, rest))

if __name__ == "__main__" : main()
