# interpreter.py
#
import sys
typeInt = type(5)

def getExpr(tokens) :
    value,rest = getTerm(tokens)
    if value == None : return None, rest
    while True :
        oper,rest = getOper(rest, ["+","-"])
        if not oper : return value,rest   # good return
        val2,rest = getTerm(rest)
        if val2 == None : fatal("getExpr","no following unit")
        if oper == "+" : value += val2
        if oper == "-" : value -= val2

def getTerm(tokens) :
    value,rest = getUnit(tokens)
    if value == None : return None, rest
    while True :
        oper,rest = getOper(rest, ["*","/"])
        if not oper : return value, rest   # good return
        val2,rest = getUnit(rest)
        if val2 == None : fatal("getTerm","no following unit")
        if oper == "*" : value *= val2
        if oper == "/" : value /= val2

def getUnit(tokens) :
    if not tokens : return (None, [])
    tok,rest = tokens[0], tokens[1:]
    if type(tok) == typeInt : return tok,rest
    elif tok == '-' :
        unit,rest = getUnit(rest)
        if unit == None : fatal("getUnit","Invalid expr")
        else : return -unit,rest
    elif tok == "(" :
        expr,rest = getExpr(rest)
        if expr == None : fatal("getUnit","Invalid sub-expr")
        tok,rest = getOper(rest,[')'])
        if tok : return (expr, rest)
        else   : fatal("getUnit","no closing paran")

def getOper(tokens, valid) :
    if tokens and tokens[0] in valid :
        return tokens[0], tokens[1:]
    else : return None, tokens

def fatal(who, mesg) :
    print("fatal -- %s %s" % (who,mesg))
    sys.exit()

def main() :
    import lexer
    code   = sys.argv[1]
    tokens = lexer.lexScan(code)
    print("Lexer gives %s" % tokens)
    value,rest = getExpr(tokens)
    print("%s %s" % (value, rest))

if __name__ == "__main__" : main()
